<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigPessoa extends Base\MigPessoa
{

    protected $dtinclusao;
    protected $dtultatu;
    protected $nrpessoa;

    /**
     * @param mixed $nrpessoa
     * @return \Folha\Entities\MigPessoa|void
     */
    public function setNrpessoa($nrpessoa)
    {
        $nrpessoa = \Importacao\Logic\Validacoes::verificaChaveDuplicada('GPE_PESSOA', 'NRPESSOA', ProjetoImportacao::getNrorg(), $nrpessoa);
        $this->nrpessoa = $nrpessoa;
    }

    /**
     * @param $nrparcnegocio
     * @throws \Exception
     * @return \Folha\Entities\MigPessoa
     */
    public function setNrparcnegocio ($nrparcnegocio) {
        $nrorg = ProjetoImportacao::getNrorg();
        $parcnegocio = \Folha\Entities\MigParcnegocio::getObjectByWhere('NRPARCNEGOCIO = ? AND NRORG = ?', array($nrparcnegocio, $nrorg));

        if (is_object($parcnegocio)) {
            $this->nrparcnegocio = $nrparcnegocio;
        } else {
            throw new \Exception("O código do Parceiro de Negócio '$nrparcnegocio' não foi encontrado.");
        }
    }

    /**
     * @param mixed $dtinclusao
     * @throws \Exception
     * @return \Folha\Entities\MigPessoa|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtultatu
     * @throws \Exception
     * @return \Folha\Entities\MigPessoa|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data com formato inválido.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

}