/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRECOUTI                                                 */
/* Tabela : PRECOUTI                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PRECOUTI' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_PRECOUTI
GO

CREATE TRIGGER DTULTATU_PRECOUTI
ON PRECOUTI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'PRECOUTI', null, 'NRSEQPREUTI='+ NRSEQPREUTI+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PRECOUTI
      SET DTULTATUPRUT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(PRECOUTI.VRPEADPBASE,0) = ISNULL(INSERTED.VRPEADPBASE,0));
   END;
END;
GO

